"{ Package: 'stx:libbasic' }"

Method variableSubclass:#SandboxedMethod
	instanceVariableNames:'methods'
	classVariableNames:''
	poolDictionaries:''
	category:'Kernel-Methods'
!


!SandboxedMethod class methodsFor:'initialization'!

initialize
    self flags:((self flags 
                    bitOr:Behavior flagMetaMethod)
                       bitClear:Behavior flagMethod)

    "
     self initialize
    "
! !

!SandboxedMethod class methodsFor:'instance creation'!

with: m1 

    ^self new 
        add: m1;
        yourself

    "Created: / 27-12-2009 / 13:31:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

with: m1 with: m2

    ^self new 
        add: m1;
        add: m2;
        yourself

    "Created: / 27-12-2009 / 08:50:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SandboxedMethod methodsFor:'accessing'!

replacementMethodFor: anotherMethod

    1 to: methods size do:
        [:idx|
        (methods at: idx) programmingLanguage = anotherMethod programmingLanguage ifTrue:
            [methods size = 1 
                ifTrue:[^anotherMethod]
                ifFalse:[methods at: idx put: anotherMethod.^self]]].

    self add: anotherMethod.            
    ^self

    "Created: / 27-12-2009 / 09:17:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SandboxedMethod methodsFor:'adding & removing'!

add: aMethod

    methods ifNil:[methods := Array with: aMethod. ^self].
    methods := methods copyWith: aMethod

    "Created: / 27-12-2009 / 08:51:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SandboxedMethod methodsFor:'error handling'!

interpretWithReceiver:rec
    "invoked by VM for non-Smalltalk-methods (MetaMethods)"

    | sandbox inhMth |
    sandbox := thisContext sender sandbox.
    methods do:
        [:mth|
        mth sandbox = sandbox 
            ifTrue:[^mth valueWithReceiver:rec arguments: #() ]].
    "No method for sandbox found, look for inherited method..."
    inhMth := rec class superclass lookupSelector: self selector.
    ^inhMth 
        ifNotNil:
            ["Good, we found one, fire it..."
            inhMth valueWithReceiver:rec arguments: #()]
        ifNil:
            ["No inherited method found, send doesNotUnderstand:"
            rec doesNotUnderstand: (Message selector: self selector arguments: #())]

    "Created: / 27-12-2009 / 00:04:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 27-12-2009 / 13:52:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver:rec arg:arg1
    "invoked by VM for non-Smalltalk-methods (MetaMethods)"

    | sandbox args inhMth |
    sandbox := thisContext sender sandbox.
    args := Array with: arg1.
    methods do:
        [:mth|
        mth sandbox = sandbox 
            ifTrue:[^mth valueWithReceiver:rec arguments: args ]].
    "No method for sandbox found, look for inherited method..."
    inhMth := rec class superclass lookupSelector: self selector.
    ^inhMth 
        ifNotNil:
            ["Good, we found one, fire it..."
            inhMth valueWithReceiver:rec arguments: args]
        ifNil:
            ["No inherited method found, send doesNotUnderstand:"
            rec doesNotUnderstand: (Message selector: self selector arguments: args)]

    "Created: / 27-12-2009 / 00:04:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 27-12-2009 / 13:50:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver:rec arg:arg1 arg: arg2
    "invoked by VM for non-Smalltalk-methods (MetaMethods)"

    | sandbox args inhMth |
    sandbox := thisContext sender sandbox.
    args := Array with: arg1 with: arg2.
    methods do:
        [:mth|
        mth sandbox = sandbox 
            ifTrue:[^mth valueWithReceiver:rec arguments: args ]].
    "No method for sandbox found, look for inherited method..."
    inhMth := rec class superclass lookupSelector: self selector.
    ^inhMth 
        ifNotNil:
            ["Good, we found one, fire it..."
            inhMth valueWithReceiver:rec arguments: args]
        ifNil:
            ["No inherited method found, send doesNotUnderstand:"
            rec doesNotUnderstand: (Message selector: self selector arguments: args)]

    "Created: / 27-12-2009 / 00:04:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 27-12-2009 / 13:51:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver:rec arg:arg1 arg: arg2 arg: arg3
    "invoked by VM for non-Smalltalk-methods (MetaMethods)"

    | sandbox args inhMth |
    sandbox := thisContext sender sandbox.
    args := Array with: arg1 with: arg2 with: arg3.
    methods do:
        [:mth|
        mth sandbox = sandbox 
            ifTrue:[^mth valueWithReceiver:rec arguments: args ]].
    "No method for sandbox found, look for inherited method..."
    inhMth := rec class superclass lookupSelector: self selector.
    ^inhMth 
        ifNotNil:
            ["Good, we found one, fire it..."
            inhMth valueWithReceiver:rec arguments: args]
        ifNil:
            ["No inherited method found, send doesNotUnderstand:"
            rec doesNotUnderstand: (Message selector: self selector arguments: args)]

    "Created: / 27-12-2009 / 00:04:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 27-12-2009 / 13:51:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

interpretWithReceiver:rec arguments: args
    "invoked by VM for non-Smalltalk-methods (MetaMethods)"

    | sandbox inhMth |
    sandbox := thisContext sender sandbox.
    methods do:
        [:mth|
        mth sandbox = sandbox 
            ifTrue:[^mth valueWithReceiver:rec arguments: args ]].
    "No method for sandbox found, look for inherited method..."
    inhMth := rec class superclass lookupSelector: self selector.
    ^inhMth 
        ifNotNil:
            ["Good, we found one, fire it..."
            inhMth valueWithReceiver:rec arguments: args]
        ifNil:
            ["No inherited method found, send doesNotUnderstand:"
            rec doesNotUnderstand: (Message selector: self selector arguments: args)]

    "Created: / 27-12-2009 / 00:04:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 27-12-2009 / 13:51:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SandboxedMethod methodsFor:'executing'!

valueWithReceiver:rec arguments:args selector:aSymbol search:aClass sender:virtualSender sandbox: sandbox

    | inhMth |

    methods do:
        [:method|
        method sandbox = sandbox 
            ifTrue:[^method valueWithReceiver:rec arguments: args ]].
    "No method for sandbox found, look for inherited method..."
    inhMth := rec class superclass lookupSelector: self selector.
    ^inhMth 
        ifNotNil:
            ["Good, we found one, fire it..."
            inhMth valueWithReceiver:rec arguments: args]
        ifNil:
            ["No inherited method found, send doesNotUnderstand:"
            rec doesNotUnderstand: (Message selector: self selector arguments: args)]

    "Created: / 27-12-2009 / 13:43:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SandboxedMethod methodsFor:'queries'!

isSandboxed
    "return true, if this is a sandboxed method"

    ^ true

    "Created: / 27-12-2009 / 00:20:45 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!SandboxedMethod class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

SandboxedMethod initialize!
